package prodcons;

import java.awt.BorderLayout;
import java.awt.Color;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

public class ConsumerView extends JPanel implements Observer {

    private Consumer consumer;
    private JLabel label;

    public ConsumerView(Consumer consumer) {
        this.consumer = consumer;
        consumer.addObserver(this);
        label = new JLabel("CONSUMER");
        label.setOpaque(true);
        label.setHorizontalTextPosition(SwingConstants.CENTER);
        setLayout(new BorderLayout());
        add(label);
    }

    @Override
    public void update(Observable o, Object arg) {
        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                Consumer.State state = consumer.getState();
                if (state == Consumer.State.CONSUMING) {
                    label.setText("Konzumuji hodnotu " + state.getValue() + ".");
                    label.setBackground(Color.GREEN);
                } else {
                    label.setText("Načítám hodnotu.");
                    label.setBackground(Color.YELLOW);
                }
            }
        });
    }
}
